;***************************************************************************
;**************           COPYFORM Version 1.0            ******************
;************** Copie et formatage indpendante des faces ******************
;**************    Par Daniel MERKEZ, le 24 Mars 1990     ******************
;***************************************************************************
	
	opt o+,ow+,t+,w+,t+
	


	include	copyform.i	
	include	geminex2.s

	section 	text
main	jsr	gem_init		;Initialisation GEM
	move.l	#$5a000,-(sp)	;Malloc de la taille du tampon
	move.w	#$48,-(sp)
	trap	#1
	addq.l	#6,sp
	tst.l	d0		;Si pas assez de mmoire
	bmi	errmem		;Branchement traitement erreur
	move.l	d0,buffer		;Sauvegarde du pointeur tampon
	
mem	move.l	#$3000,-(sp)
	move.w	#$48,-(sp)
	trap	#1
	addq.l	#6,sp
	tst.l	d0
	bmi	errmem
	move.l	d0,bufform
;Initialisation de la forme du pointeur de la souris

	moveq.w	#78,d1	;graf_mouse
	move.l	#$01010100,d0
	clr.w	int_in		;0 pour fleche
	jsr	aes
	

;Test du nombre d'unit disque connectes

	move.l	#ndisque,-(sp)	;Adresse de la routine sur sp
	move.w	#38,-(sp)		;Supexec
	trap	#14
	addq.l	#6,sp
	
;Chargement du fichier ressource par rsrc_load

	moveq.w	#110,d1		;Rsrc_load
	move.l	#$00010100,d0
	move.l	#nomrsc,addr_in
	jsr	aes
	
	tst.w	int_out	;Y a-t-il erreur?
	beq	rscerr	;alors on va la traiter
	

;On cherche l'adresse de la ressource par rsrc_gaddr

	moveq.w	#112,d1		;Rsrc_Gaddr
	move.l	#$02010100,d0
	move.l	#FORMCOPY,int_in		;0 pour 'Recherche d'arbre'
;	move.w	#FORMCOPY,int_in+2	;Index de l'arbre
	jsr	aes
	move.l	addr_out,adr_arbre	;On met l'adresse dans la variable

; On slectionne les boutons des disques d'aprs nbdisk

	move.w	#SOURCEA,bouton	; On slectionne le source A
	clr.w	unlec
	jsr	select
	cmpi.w	#2,nbdisk
	beq.s	.a
	move.w	#DESTINA,bouton
	clr.w	unecr
	jsr	select
	bra.s	suite
.a	move.w	#DESTINB,bouton
	move.w	#1,unecr
	jsr	select
suite	move.w	#SOURCEF2,bouton
	jsr	select
	move.w	#DESTINF1,bouton
	jsr	select
		
	jsr	dess_form
		
;On active le formulaire avec form_do

formdo	moveq.w	#50,d1		;Form_do
	move.l	#$1010100,d0
	move.w	#-1,int_in
	move.l	adr_arbre,addr_in
	jsr	aes

;Traitement des rsultats du formulaire

	move.w	int_out,bouton	;On sauvegarde l'index du bouton
	move.w	bouton,d0	
	jsr	deselect		;On dselectionne ce bouton
	cmp.w	#QUITTER,bouton	;si bouton QUITTER
	beq	fingem		;on quitte tout
	cmp.w	#INFO,bouton
	beq	info
;on vrifie l'tat des radio-buttons et on sauvegarde dans les variables

	move.w	#SOURCEB,selbout
	jsr	sisel
	cmpi.w	#1,d0
	beq.s	.d
	clr.w	unlec
.d	move.w	d0,unlec
	move.w	#DESTINB,selbout
	jsr	sisel
	cmpi.w	#1,d0
	beq.s	.e
	clr.w	unecr
.e	move.w	d0,unecr
	move.w	#SOURCEF2,selbout
	jsr	sisel
	cmpi.w	#1,d0
	beq.s	.f
	clr.w	faclec
.f	move.w	d0,faclec
	move.w	#DESTINF2,selbout
	jsr	sisel
	cmpi.w	#1,d0
	beq.s	.g
	clr.w	facecr
.g	move.w	d0,facecr
			
	cmp.w	#COPIER,bouton	;si pas bouton COPIER
	bne.s	.format		;on passe au test suivant
	bsr	copier		;sinon, on va copier
	bra	formdo
	
.format	cmp.w	#FORMATER,bouton	;si bouton FORMATER
	bsr	formater		;eh, on formate, pardi
	bra	formdo		;et on reboucle le tout

;Sous-programme de dessin d'un formulaire  l'cran

dess_form	moveq.w	#54,d1
	move.l	#$00050100,d0
	move.l	adr_arbre,addr_in
	jsr	aes
	move.l	int_out+2,ox	;sauvegarde des coordonnes
;	move.w	int_out+4,oy	;du formulaire dans des
	move.l	int_out+6,ow	;variables
;	move.w	int_out+8,oh
	
; Sauvegarde les cadres des fenetres avec form_dial(0)

	moveq.w	#51,d1
	move.l	#$9010000,d0
	clr.w	int_in		;fonction form_dial 0
	move.l	ox,int_in+10
;	move.w	oy,int_in+12
	move.l	ow,int_in+14
;	move.w	oh,int_in+16
	jsr	aes
	
; Dessin du rectangle avec form_dial(1)

	moveq.w	#51,d1
	move.l	#$9010000,d0
	move.w	#1,int_in		;fonction form_dial 1
	move.l	ox,int_in+2
;	move.w	oy,int_in+4
	move.l	#10001,int_in+6
;	move.w	#1,int_in+8
	move.l	ox,int_in+10
;	move.w	oy,int_in+12
	move.l	ow,int_in+14
;	move.w	oh,int_in+16
	jsr	aes
	
; Dessiner dialog avec objc_draw

objdraw	moveq.w	#42,d1
	move.l	#$6010100,d0
	move.l	#12,int_in	;12 niveaux maxi
	move.l	ox,int_in+4
;	move.w	oy,int_in+6
	move.l	ow,int_in+8
;	move.w	oh,int_in+10
	move.l	adr_arbre,addr_in
	jsr	aes
	rts
	
; Routine d'affichage d'une boite d'alerte
; on passe juste l'adresse dans a0

formalert	moveq.w	#52,d1
	move.l	#$1010100,d0
	move.w	#1,int_in
	move.l	a0,addr_in
	jsr	aes
	rts

		
; Routine de slection d'un bouton du formulaire

select	movea.l	adr_arbre,a0
	move.w	bouton,d0	;Index de l'objet
	mulu.w	#24,d0	;* 24 (chaque objet = 24 octets)
	ori.w	#1,10(a0,d0.w) ;Mettre le bit 0 (selected)  1
	rts

; Routine de dslection d'un bouton du formulaire

deselect	moveq.w	#47,d1		;Objc_change
	move.l	#$8010100,d0
	move.w	d0,int_in
	clr.w	int_in+2
	move.l	ox,int_in+4
;	move.w	oy,int_in+6
	move.l	ow,int_in+8
;	move.w	oh,int_in+10
	move.l	#1,int_in+12
	move.l	adr_arbre,addr_in
	jsr	aes
	rts

deselect2	moveq.w	#47,d1		;Objc_change
	move.l	#$8010100,d0
	move.w	d0,int_in
	clr.w	int_in+2
	move.l	fox,int_in+4
;	move.w	foy,int_in+6
	move.l	fow,int_in+8
;	move.w	foh,int_in+10
	move.l	#1,int_in+12
	move.l	arbre_adr,addr_in
	jsr	aes
	rts

; Inscription d'un texte dans une structure TedInfo

writetext	movea.l	adr_arbre,a1	;on met l'adresse dans l'arbre dans a1
	move.w	bouton,d0		;on met l'index dans d0
	mulu.w	#24,d0		;on multiplie l'index par 24
	movea.l	12(a1,d0.w),a1	;On obtient l'adresse de la struc
	movea.l	(a1),a1		;dans a1
	
wrt_lp	move.b	(a0)+,(a1)+	;on transfere le texte de a0  a1
	bne.s	wrt_lp		;si pas fini, on reboucle
	rts
	
; libration du ressource avec rsrc_free

fingem	lea.l	txtfin,a0
	jsr	formalert
	moveq.w	#111,d1
	move.l	#$00010000,d0
	jsr	aes
	
; fin du programme

quit	jsr	gem_exit
	clr.w	-(sp)
	trap	#1
		
; Routine de test de slection d'un objet

sisel	movea.l	adr_arbre,a0
	move.w	selbout,d1
	mulu.w	#24,d1
	move.w	10(a0,d1.w),d0
	andi.w	#1,d0
	rts
;Affichage du formulaire d'infos

info	moveq.w	#112,d1
	move.l	#$2010001,d0
	move.l	#INFORM,int_in	;Index de l'arbre
	jsr	aes
	move.l	addr_out,arbre_adr	;On met l'adresse dans la variable
	moveq.w	#54,d1
	move.l	#$00050100,d0
	move.l	arbre_adr,addr_in
	jsr	aes
	move.l	int_out+2,fox	;sauvegarde des coordonnes
;	move.w	int_out+4,foy	;du formulaire dans des
	move.l	int_out+6,fow	;variables
;	move.w	int_out+8,foh
	
; Sauvegarde les cadres des fenetres avec form_dial(0)

	moveq.w	#51,d1
	move.l	#$9010000,d0
	clr.w	int_in		;fonction form_dial 0
	move.l	fox,int_in+10
;	move.w	foy,int_in+12
	move.l	fow,int_in+14
;	move.w	foh,int_in+16
	jsr	aes
	
; Dessin du rectangle avec form_dial(1)

;	moveq.w	#51,d1
;	move.l	#$9010000,d0
;	move.w	#1,int_in		;fonction form_dial 1
;	move.l	fox,int_in+2
;	move.w	foy,int_in+4
;	move.l	#$10001,int_in+6
;	move.w	#1,int_in+8
;	move.l	fox,int_in+10
;	move.w	foy,int_in+12
;	move.l	fow,int_in+14
;	move.w	foh,int_in+16
;	jsr	aes
	
; Dessiner dialog avec objc_draw

	moveq.w	#42,d1
	move.l	#$6010100,d0
	move.l	#12,int_in	;12 niveaux maxi
	move.l	fox,int_in+4
;	move.w	foy,int_in+6
	move.l	fow,int_in+8
;	move.w	foh,int_in+10
	move.l	arbre_adr,addr_in
	jsr	aes

; Fonction Form_do

	moveq.w	#50,d1
	move.l	#$1010100,d0
	move.w	#-1,int_in
	move.l	arbre_adr,addr_in
	jsr	aes
	move.w	#OK,d0
	jsr	deselect2

	moveq.w	#51,d1
	move.l	#$9010000,d0
	clr.l	control+6
	move.w	#4,int_in		;fonction form_dial 3
	move.l	fox,int_in+10
;	move.w	foy,int_in+12
	move.l	fow,int_in+14
;	move.w	foh,int_in+16
	jsr	aes
	jsr	objdraw
	bra	formdo

; Redessin d'un lment du formulaire

dessin	moveq.w	#42,d1		;Objc_draw
	move.l	#$6010100,d0
	move.w	bouton,int_in	;dessiner l'objet racine d0 en premier
	move.w	#12,int_in+2	;12 niveaux maxi
	move.l	ox,int_in+4
;	move.w	oy,int_in+6
	move.l	ow,int_in+8
;	move.w	oh,int_in+10
	move.l	adr_arbre,addr_in
	jsr	aes
	rts

; Routine de formatage

formater	move.w	#79,d3		;80 pistes  formater
	lea.l	txtform,a0	;On signale qu'on formate
	move.w	#LECTECR,bouton	;dans le formulaire
	jsr	writetext		;on l'inscrit
	bsr.s	dessin		;et on le dessine
	move.w	faclec,d0		;on fait pareil pour la face
	add.w	#$31,d0		; formater
	move.b	d0,efaclec
	lea.l	efaclec,a0
	move.w	#FACE,bouton
	jsr	writetext
	bsr.s	dessin
.form	move.w	d3,d2		;transformation du numro de
	lea.l	piste,a5		;piste en code ascii qu'on
	bsr	decimal		;pourra ensuite inscrire
	clr.w	d0		;et dessiner dans le formulaire
	move.b	piste,d0		
	move.b	piste+1,piste
	move.b	d0,piste+1
	lea.l	piste,a0
	move.w	#PISTE,bouton
	jsr	writetext
	bsr	dessin
	move.l	#$e5e58765,-(sp)	;valeur de remplissage des secteurs
	move.l	#$43210001,-(sp)	;nombre magique de formatage
;	move.w	#1,-(sp)		;interleave
	move.w	faclec,-(sp)	;face de formattage
	move.w	d3,-(sp)		;numro de la piste  formatter
	move.w	#9,-(sp)		;nombre de secteurs par piste
	move.w	unlec,-(sp)	;unit  formater
	clr.l	-(sp)
	move.l	bufform,-(sp)	;buffer de formatage
	move.w	#10,-(sp)		;Flopfmt
	trap	#14
	lea.l	26(sp),sp
	tst	d0
	bpl.s	.contform
	cmp.w	#-16,d0		;on voit s'il y a erreur
	beq	formerr		;on traite
	cmp.w	#-13,d0		;on voit si le disk est protg
	bsr	proterr		;on traite
	move.w	error,d0
	tst	d0
	bmi	finform
	clr.w	error
	bra	.form
.contform	dbf	d3,.form		;on reboucle jusqu' la fin
	lea.l	formfin,a0	;on signale la fin du formatage
	bsr	formalert		;et on l'affiche en formalert
finform	bsr	efftout
	rts

efftout	lea.l	efface,a0		;on remet tout dans l'tat dans
	move.w	#LECTECR,bouton	;lequel on trouv le formulaire
	jsr	writetext
	bsr	dessin
	lea.l	zero,a0
	move.w	#PISTE,bouton
	jsr	writetext
	bsr	dessin
	lea.l	zero,a0
	move.w	#SECTEUR,bouton
	jsr	writetext
	bsr	dessin
	rts
	
; Routine de copie	
copier	bra.s	lecture	;D'abord, on lit la face
finlec	bsr.s	efftout

	move.w	unlec,d0	;si l'unit de lecture est la meme que
	cmp.w	unecr,d0	;celle d'criture, on affiche une boite
	bne.s	.ecr	;d'alerte qui demande de changer de disquette
	lea.l	autrdis,a0 ;sinon, on passe directement  l'criture
	jsr	formalert
.ecr	bra	ecriture	;Ecriture
	lea.l	copterm,a0
	jsr	formalert
finecr	bsr.s	efftout
	rts
	
; Routine de lecture d'une face de disquette

lecture	clr.w	d3		;Initialisation des paramtres
	move.l	buffer,d4		;de copie
	moveq.w	#1,d5

	lea.l	txtlec,a0
	move.w	#LECTECR,bouton
	jsr	writetext
	bsr	dessin
	move.w	faclec,d0
	add.w	#$31,d0
	move.b	d0,efaclec
	lea.l	efaclec,a0
	move.w	#FACE,bouton
	jsr	writetext
	bsr	dessin
pistlec	move.w	d3,d2
	lea.l	piste,a5
	bsr	decimal
	clr.w	d0
	move.b	piste,d0
	move.b	piste+1,piste
	move.b	d0,piste+1
	lea.l	piste,a0
	move.w	#PISTE,bouton
	jsr	writetext
	bsr	dessin
	
sectlec	move.w	d5,d2
	addi.w	#$30,d2
	move.b	#$30,secteur
	move.b	d2,secteur+1
	lea.l	secteur,a0
	move.w	#SECTEUR,bouton
	jsr	writetext
	bsr	dessin
	
	move.w	#1,-(sp)	;Nombre de secteurs  etre lus conscutivement
	move.w	faclec,-(sp)	;Face  lire
	move.w	d3,-(sp)	;Piste  lire
	move.w	d5,-(sp)	;Numro du 1er secteur  lire
	move.w	unlec,-(sp);Numro de l'unit de disquette
	clr.l	-(sp)
	move.l	d4,-(sp)	;Buffer de stockage de donnes
	move.w	#8,-(sp)	;FlopRd
	trap	#14
	lea.l	20(sp),sp
	tst	d0	;Si erreur,
	bmi	lecerr	;directos au traitement d'erreurs
contlec	add.l	#512,d4	;Rajustement du pointeur de tampon
	addq.w	#1,d5	;Incrmentation du numro de secteur
	cmpi.w	#10,d5	;Si le secteur est infrieur  10
	bne.s	sectlec	;Alors, on se refarcit une lecture
	moveq.w	#1,d5	;sinon, on remet le secteur  1
	addq.w	#1,d3	;Et c'est au tour de numro de piste
	cmpi.w	#80,d3	;S'il est infrieur  80
	bne	pistlec	;Meme topo que pour le secteur
	bra	finlec

; Normalement, on a fini de lire le disque source
; Maintenant, il ne reste plus qu' crire le disque destination
; La plupart des oprations sont les memes que pour la lecture du disque
; Il n'y a que la face et l'unit de disquette qui change

; Routine d'criture d'une face de disquette

ecriture	clr.w	d3
	moveq.w	#1,d5
	move.l	buffer,d4
	
	lea.l	txtecr,a0
	move.w	#LECTECR,bouton
	jsr	writetext
	bsr	dessin
	move.w	facecr,d0
	add.w	#$31,d0
	move.b	d0,efacecr
	lea.l	efacecr,a0
	move.w	#FACE,bouton
	jsr	writetext
	bsr	dessin

pistecr	move.w	d3,d2
	lea.l	piste,a5
	bsr	decimal
	clr.w	d0
	move.b	piste,d0
	move.b	piste+1,piste
	move.b	d0,piste+1
	lea.l	piste,a0
	move.w	#PISTE,bouton
	jsr	writetext
	bsr	dessin
	
sectecr	move.w	d5,d2
	addi.w	#$30,d2
	move.b	#$30,secteur
	move.b	d2,secteur+1
	lea.l	secteur,a0
	move.w	#SECTEUR,bouton
	jsr	writetext
	bsr	dessin
	

	move.w	#1,-(sp)
	move.w	facecr,-(sp)
	move.w	d3,-(sp)
	move.w	d5,-(sp)
	move.w	unecr,-(sp)	;Ecrire sur le lecteur B
	clr.l	-(sp)
	move.l	d4,-(sp)
	move.w	#9,-(sp)	;FlopWr
	trap	#14
	lea.l	20(sp),sp
	tst	d0
	bpl	contecr
	cmpi	#-13,d0
	bne.s	.dan
	bsr	proterr
	move.w	error,d0
	tst	d0
	bmi	finecr
	clr.w	error
	bra.s	sectecr
.dan	bra	ecrerr
contecr	add.l	#512,d4
	addq.w	#1,d5
	cmpi.w	#10,d5
	bne	sectecr
	moveq.w	#1,d5
	addq.w	#1,d3
	cmpi.w	#80,d3
	bne	pistecr
	bra	finecr

; Routine de conversion d'un nombre en affichage ascii

decimal	move.l	d2,d1
	cmpi.w	#10,d3
	blt	.fin2
	divu	#10,d1
	move.w	d1,d2
	swap.w	d1
	addi.w	#$30,d1
	move.b	d1,(a5)+
	cmpi.w	#0,d2
	bne.s	decimal
	rts
.fin2	addi.w	#$30,d1
	move.b	#$30,piste+1
	move.b	d1,piste
	rts

; Routine de dtermination du nbre d'units connectes

ndisque	lea	$4a6,a0
	move.w	(a0),nbdisk
	rts
	
; Traitement des erreur

errmem	lea.l	txtmem,a0		;Erreur mmoire
	jsr	formalert
	bra	fingem
	
proterr	clr.w	error
	lea.l	protxt,a0		;Disquette protge
	jsr	formalert
	move.w	int_out,d0
	cmp.w	#1,d0
	beq.s	.finprot
	move.w	#-1,error
.finprot	rts
	
formerr	lea.l	formertxt,a0	;Erreur de formatage
	jsr	formalert
	bra	finform
	
rscerr	lea.l	txtrsc,a0		;Erreur de chargement de ressource
	jsr	formalert
	bra	fingem
	
lecerr	lea.l	txterlec,a0	;Erreur de lecture
	jsr	formalert
	move.w	int_out,d0
	cmp.w	#1,d0
	beq	contlec
	bra	finecr

ecrerr	lea.l	txterecr,a0	;Erreur d'criture
	jsr	formalert
	move.w	int_out,d0
	cmp.w	#1,d0
	beq	contecr
	bra	finecr
		
fin	lea.l	txtfin,a0		;Message de fin
	jsr	formalert
	bra	fingem	


	section	data
	
txtmem	dc.b	'[3][Pas assez de mmoire][FIN]',0
	even
formfin	dc.b	'[1][Formatage termin][FIN]',0
	even
autrdis	dc.b	'[3][Insrez la disquette|de destination][  OK  ]',0
	even
formertxt	dc.b	'[3][Une erreur de formatage|est apparue][FIN]',0
	even
protxt	dc.b	'[3][Votre disquette est protge][CONTINUER|   FIN   ]',0
	even
txterlec	dc.b	'[3][Une erreur de lecture|est apparue][CONTINUER|   FIN   ]',0
	even
txterecr	dc.b	'[3][Une erreur d''criture|est apparue][CONTINUER|   FIN   ]',0
	even
txtrsc	dc.b	'[3][Pas de fichier RSC !][FIN]',0
	even
copterm	dc.b	'[1][Copie termine][FIN]',0
	even
txtfin	dc.b	'[1][Allez! C''est tout|pour aujourd''hui!][FIN]',0
	even
txtform	dc.b	'FORMATER',0
	even
efface	dc.b	'        ',0
	even
zero	dc.b	'00',0
	even
txtlec	dc.b	'LECTURE ',0
	even
txtecr	dc.b	'ECRITURE',0
	even
nomrsc	dc.b	'copyform.rsc',0
	even
efaclec	dc.b	'1',0
	even
efacecr	dc.b	'1',0
	even
			
	section	bss
	
adr_arbre	ds.l	1
arbre_adr	ds.l	1
ox	ds.w	1
oy	ds.w	1
ow	ds.w	1
oh	ds.w	1
fox	ds.w	1
foy	ds.w	1
fow	ds.w	1
foh	ds.w	1
error	ds.w	1
faclec	ds.w	1
unlec	ds.w	1
facecr	ds.w	1
unecr	ds.w	1
bouton	ds.w	1
selbout	ds.w	1
nbdisk	ds.w	1
piste	ds.b	3
secteur	ds.b	3
buffer	ds.l	1
bufform	ds.l	1

	